#include <stdio.h>
#include <math.h>
#include <stdlib.h>

double f(double x) {
  return ( x*x*exp(-x) + exp(-(x-1)*(x-1.)/2.) );
}

double runif(double min, double max) {
  double rzerouno;
  if(min >= max) return(0);  
  rzerouno =  (double) rand() / (double) RAND_MAX;
  return( min + rzerouno * (max-min) );
}

int rf(double a, double b, double h, int n, double rx[]) {
  double x, y;
  int i, nsotto = 0;
  
  for (i=0; i<n; i++) {
    x = runif(a, b);
    y = runif(0, h);
    if (y < f(x)) {
      rx[nsotto] = x; 
      nsotto++;
    }
  }
  return(nsotto);
}

void binning(int nrx, double rx[], double a, double b, int nbins, int bins[]) {
  double dx = (b - a)/ (double) nbins;
  int i, nb;
  for (i=0; i<nbins; i++) {
    bins[i] = 0;
  }
  for (i=0; i<nrx; i++) {
    nb = (rx[i] - a) / dx;
    bins[nb]++;
  }
}

int main(int argc, char *argv[]) {
  double a, b, h, integrale;
  int n, nrx;
  if (argc < 5) {
    printf("Devi dare a, b, h e n a riga di comando\n");
    printf("Ad es.:  ./integrale 1 3 2 100000\n");
    return 0;
  }
  a = atof(argv[1]);
  b = atof(argv[2]);
  h = atof(argv[3]);
  n = atof(argv[4]);
  printf("Valori ricevuti: \n");
  printf("a = %.2f \n", a);
  printf("b = %.2f \n", b);
  printf("h = %.2f \n", h);
  printf("n = %d \n", n);
  if (a < 0 || h < 0 || (b <= a) || (n <= 0) ) {
    printf("*** Valori non accettabili: \n");
    printf("             devono essere: 0 <= a < b\n");
    printf("                            h > 0\n");
    printf("                            n > 0 (e 'grande')\n");
  }

  srand(1234567);

  double rx[n];  
  nrx = rf(a, b, h, n, rx);
  printf("rx[] contiene %d valori validi\n", nrx);

  int nbins = 100, i;
  int bins[nbins];
  
  binning(nrx, rx, a, b, nbins, bins);

  double dx = (b - a)/ (double) nbins;
  for (i=0; i<nbins; i++) {
    printf("%3d  xc = %.3f  n = %5d\n", i, a + i*dx + dx/2., bins[i]);
  }

  FILE *fp;
  fp = fopen("bins.txt", "w");
  for (i=0; i<nbins; i++) {
    fprintf(fp, "%3d   %.3f %5d\n", i, a + i*dx + dx/2., bins[i]);
  }
  fclose(fp);
  
  return 0;
}
