#include <stdio.h>
#include <math.h>
#include <stdlib.h>

double f(double x) {
  return ( x*x*exp(-x) + exp(-(x-1)*(x-1.)/2.) );
}

double runif(double min, double max) {
  double rzerouno;
  if(min >= max) return(0);  
  rzerouno =  (double) rand() / (double) RAND_MAX;
  return( min + rzerouno * (max-min) );
}

double intHM(double a, double b, double h, int n) {
  double x, y;
  int i, nsotto = 0;
  
  for (i=0; i<n; i++) {
    x = runif(a, b);
    y = runif(0, h);
    if (y < f(x))
      nsotto++;
  }
  
  return( (double) nsotto / (double) n * (b-a) * h );
}

int main(int argc, char *argv[]) {
  double a, b, h, integrale;
  int n;
  if (argc < 5) {
    printf("Devi dare a, b, h e n a riga di comando\n");
    printf("Ad es.:  ./integrale 1 3 2 1000000\n");
    return 0;
  }
  a = atof(argv[1]);
  b = atof(argv[2]);
  h = atof(argv[3]);
  n = atof(argv[4]);
  printf("Valori ricevuti: \n");
  printf("a = %.2f \n", a);
  printf("b = %.2f \n", b);
  printf("h = %.2f \n", h);
  printf("n = %d \n", n);
  if (a < 0 || h < 0 || (b <= a) || (n <= 0) ) {
    printf("*** Valori non accettabili: \n");
    printf("             devono essere: 0 <= a < b\n");
    printf("                            h > 0\n");
    printf("                            n > 0 (e 'grande')\n");
  }
 
  srand(1234567);

  integrale = intHM(a, b, h, n);
  printf("integrale : %f\n", integrale); 
  
  return 0;
}
